// $ANTLR 2.7.7 (20141010): "ProofNavigator.g" -> "PNParser.java"$

  package fmrisc.ProofNavigator;
  import fmrisc.ProofNavigator.Syntax.*;
  import fmrisc.ProofNavigator.Commands.*;
  import java.util.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class PNParser extends antlr.LLkParser       implements PNParserTokenTypes
 {

protected PNParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public PNParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected PNParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public PNParser(TokenStream lexer) {
  this(lexer,1);
}

public PNParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final Command  main() throws RecognitionException, TokenStreamException {
		 Command value = null; Declaration d = null;  
  Expression vexp = null; Vector v = null; Vector w = null; ;
		
		Token  i = null;
		Token  l = null;
		Token  lg = null;
		Token  l2 = null;
		Token  l3 = null;
		Token  ls0 = null;
		Token  ls1 = null;
		Token  j = null;
		Token  j0 = null;
		Token  m = null;
		Token  ei0 = null;
		Token  ei1 = null;
		Token  el0 = null;
		Token  el1 = null;
		Token  ii = null;
		Token  il = null;
		Token  gl = null;
		Token  ul = null;
		Token  rl = null;
		Token  pi = null;
		Token  sl = null;
		Token  gi = null;
		Token  ti = null;
		Token  vi = null;
		Token  fi = null;
		Token  str = null;
		Token  oi = null;
		Token  vstr = null;
		Token  cstr = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case IDENT:
			{
				d=declaration();
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new DeclarationC(d);
				}
				break;
			}
			case LITERAL_tcc:
			{
				match(LITERAL_tcc);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new TCC();
				}
				break;
			}
			case LITERAL_prove:
			{
				match(LITERAL_prove);
				i = LT(1);
				match(IDENT);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Prove(Construct.reference(i.getText()));
				}
				break;
			}
			case LITERAL_flip:
			{
				match(LITERAL_flip);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				l = LT(1);
				match(LABEL);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false); 
					value = new Flip(l.getText());
				}
				break;
			}
			case LITERAL_goal:
			{
				match(LITERAL_goal);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				lg = LT(1);
				match(LABEL);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false); 
					value = new Goal(lg.getText());
				}
				break;
			}
			case LITERAL_skolemize:
			{
				match(LITERAL_skolemize);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Skolemize();
				}
				break;
			}
			case LITERAL_flatten:
			{
				match(LITERAL_flatten);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Flatten();
				}
				break;
			}
			case LITERAL_split:
			{
				match(LITERAL_split);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				{
				switch ( LA(1)) {
				case LABEL:
				{
					l2 = LT(1);
					match(LABEL);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false); 
					if (l2 == null)
					value = new Split(null);
					else
					value = new Split(l2.getText());
				}
				break;
			}
			case LITERAL_simplify:
			{
				match(LITERAL_simplify);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				{
				switch ( LA(1)) {
				case LABEL:
				{
					l3 = LT(1);
					match(LABEL);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false); 
					if (l3 == null)
					value = new Simplify(null);
					else
					value = new Simplify(l3.getText());
				}
				break;
			}
			case LITERAL_decompose:
			{
				match(LITERAL_decompose);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Decompose();
				}
				break;
			}
			case LITERAL_scatter:
			{
				match(LITERAL_scatter);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Scatter();
				}
				break;
			}
			case LITERAL_auto:
			{
				match(LITERAL_auto);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				{
				switch ( LA(1)) {
				case LABEL:
				{
					ls0 = LT(1);
					match(LABEL);
					if ( inputState.guessing==0 ) {
						v = new Vector(); v.add(ls0.getText());
					}
					{
					_loop6:
					do {
						if ((LA(1)==18)) {
							match(18);
							ls1 = LT(1);
							match(LABEL);
							if ( inputState.guessing==0 ) {
								v.add(ls1.getText());
							}
						}
						else {
							break _loop6;
						}
						
					} while (true);
					}
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				if ( inputState.guessing==0 ) {
					State.setLabels(false);
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					if (v == null)
						   value = new Auto(null);
						 else
						   value = new Auto(ASTUtil.toStringArray(v));
				}
				break;
			}
			case LITERAL_autostar:
			{
				match(LITERAL_autostar);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new AutoStar();
				}
				break;
			}
			case LITERAL_counterexample:
			{
				match(LITERAL_counterexample);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new CounterExample();
				}
				break;
			}
			case LITERAL_assume:
			{
				match(LITERAL_assume);
				vexp=valueExp();
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Assume(vexp);
				}
				break;
			}
			case LITERAL_case:
			{
				match(LITERAL_case);
				vexp=valueExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(vexp);
				}
				{
				_loop8:
				do {
					if ((LA(1)==18)) {
						match(18);
						vexp=valueExp();
						if ( inputState.guessing==0 ) {
							v.add(vexp);
						}
					}
					else {
						break _loop8;
					}
					
				} while (true);
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Case(ASTUtil.toExpressionArray(v));
				}
				break;
			}
			case LITERAL_lemma:
			{
				match(LITERAL_lemma);
				j = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(Construct.reference(j.getText()));
				}
				{
				_loop10:
				do {
					if ((LA(1)==18)) {
						match(18);
						j0 = LT(1);
						match(IDENT);
						if ( inputState.guessing==0 ) {
							v.add(Construct.reference(j0.getText()));
						}
					}
					else {
						break _loop10;
					}
					
				} while (true);
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Lemma(ASTUtil.toReferenceArray(v));
				}
				break;
			}
			case LITERAL_instantiate:
			{
				match(LITERAL_instantiate);
				vexp=valueExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(vexp);
				}
				{
				_loop12:
				do {
					if ((LA(1)==18)) {
						match(18);
						vexp=valueExp();
						if ( inputState.guessing==0 ) {
							v.add(vexp);
						}
					}
					else {
						break _loop12;
					}
					
				} while (true);
				}
				match(LITERAL_in);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				m = LT(1);
				match(LABEL);
				if ( inputState.guessing==0 ) {
					State.setLabels(false);
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Instantiate(m.getText(), ASTUtil.toExpressionArray(v));
				}
				break;
			}
			case LITERAL_typeaxiom:
			{
				match(LITERAL_typeaxiom);
				vexp=valueExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(vexp);
				}
				{
				_loop14:
				do {
					if ((LA(1)==18)) {
						match(18);
						vexp=valueExp();
						if ( inputState.guessing==0 ) {
							v.add(vexp);
						}
					}
					else {
						break _loop14;
					}
					
				} while (true);
				}
				match(LITERAL_in);
				vexp=valueExp();
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new TypeAxiom(vexp, ASTUtil.toExpressionArray(v));
				}
				break;
			}
			case LITERAL_expand:
			{
				match(LITERAL_expand);
				ei0 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					w = new Vector(); w.add(Construct.reference(ei0.getText()));
				}
				{
				_loop16:
				do {
					if ((LA(1)==18)) {
						match(18);
						ei1 = LT(1);
						match(IDENT);
						if ( inputState.guessing==0 ) {
							w.add(Construct.reference(ei1.getText()));
						}
					}
					else {
						break _loop16;
					}
					
				} while (true);
				}
				{
				switch ( LA(1)) {
				case LITERAL_in:
				{
					match(LITERAL_in);
					if ( inputState.guessing==0 ) {
						State.setLabels(true);
					}
					el0 = LT(1);
					match(LABEL);
					if ( inputState.guessing==0 ) {
						v = new Vector(); v.add(el0.getText());
					}
					{
					_loop19:
					do {
						if ((LA(1)==18)) {
							match(18);
							el1 = LT(1);
							match(LABEL);
							if ( inputState.guessing==0 ) {
								v.add(el1.getText());
							}
						}
						else {
							break _loop19;
						}
						
					} while (true);
					}
					if ( inputState.guessing==0 ) {
						State.setLabels(false);
					}
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					if (v == null)
						value = new Expand(ASTUtil.toReferenceArray(w), null);
					else 
					value = new Expand(ASTUtil.toReferenceArray(w), 
						                   ASTUtil.toStringArray(v));
				}
				break;
			}
			case LITERAL_induction:
			{
				match(LITERAL_induction);
				{
				switch ( LA(1)) {
				case IDENT:
				{
					ii = LT(1);
					match(IDENT);
					{
					switch ( LA(1)) {
					case LITERAL_in:
					{
						match(LITERAL_in);
						if ( inputState.guessing==0 ) {
							State.setLabels(true);
						}
						il = LT(1);
						match(LABEL);
						if ( inputState.guessing==0 ) {
							State.setLabels(false);
						}
						break;
					}
					case SEMICOLON:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					if (ii == null)
						   value = new Induction(null, null);
						 else if (il == null)
					value = new Induction(Construct.reference(ii.getText()), null);
						 else
						   value = new Induction(Construct.reference(ii.getText()), il.getText());
					
				}
				break;
			}
			case LITERAL_open:
			{
				match(LITERAL_open);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Open();
				}
				break;
			}
			case LITERAL_next:
			{
				match(LITERAL_next);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Next();
				}
				break;
			}
			case LITERAL_prev:
			{
				match(LITERAL_prev);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Prev();
				}
				break;
			}
			case LITERAL_goto:
			{
				match(LITERAL_goto);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				gl = LT(1);
				match(LABEL);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false);
					value = new Goto(gl.getText());
				}
				break;
			}
			case LITERAL_undo:
			{
				match(LITERAL_undo);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				{
				switch ( LA(1)) {
				case LABEL:
				{
					ul = LT(1);
					match(LABEL);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false);
					if (ul == null)
					value = new Undo(null);
					else
					value = new Undo(ul.getText());
				}
				break;
			}
			case LITERAL_redo:
			{
				match(LITERAL_redo);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				{
				switch ( LA(1)) {
				case LABEL:
				{
					rl = LT(1);
					match(LABEL);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false);
					if (rl == null)
					value = new Redo(null);
					else
					value = new Redo(rl.getText());
				}
				break;
			}
			case LITERAL_environment:
			{
				match(LITERAL_environment);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new EnvironmentC();
				}
				break;
			}
			case LITERAL_proof:
			{
				match(LITERAL_proof);
				{
				switch ( LA(1)) {
				case IDENT:
				{
					pi = LT(1);
					match(IDENT);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					if (pi == null)
					value = new ProofC(null);
					else
					value = new ProofC(Construct.reference(pi.getText()));
				}
				break;
			}
			case LITERAL_state:
			{
				match(LITERAL_state);
				if ( inputState.guessing==0 ) {
					State.setLabels(true);
				}
				{
				switch ( LA(1)) {
				case LABEL:
				{
					sl = LT(1);
					match(LABEL);
					if ( inputState.guessing==0 ) {
						State.setLabels(false);
					}
					{
					switch ( LA(1)) {
					case IDENT:
					{
						gi = LT(1);
						match(IDENT);
						break;
					}
					case SEMICOLON:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					State.setLabels(false);
					if (sl == null)
					value = new StateC(null, null);
					else if (gi == null)
					value = new StateC(sl.getText(), null);
					else
					value = new StateC(sl.getText(), Construct.reference(gi.getText()));
				}
				break;
			}
			case LITERAL_printt:
			{
				match(LITERAL_printt);
				ti = LT(1);
				match(IDENT);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new TypeC(Construct.reference(ti.getText()));
				}
				break;
			}
			case LITERAL_printv:
			{
				match(LITERAL_printv);
				vi = LT(1);
				match(IDENT);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new ValueC(Construct.reference(vi.getText()));
				}
				break;
			}
			case LITERAL_printf:
			{
				match(LITERAL_printf);
				fi = LT(1);
				match(IDENT);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new FormulaC(Construct.reference(fi.getText()));
				}
				break;
			}
			case LITERAL_quit:
			{
				match(LITERAL_quit);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Quit();
				}
				break;
			}
			case LITERAL_read:
			{
				match(LITERAL_read);
				str = LT(1);
				match(STRING);
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					
						String s = str.getText();
						value = new Read(s.substring(1,s.length()-1));
					
				}
				break;
			}
			case LITERAL_option:
			{
				match(LITERAL_option);
				oi = LT(1);
				match(IDENT);
				{
				switch ( LA(1)) {
				case 45:
				{
					match(45);
					vstr = LT(1);
					match(STRING);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					
						if (vstr == null)
						  value = new Option(oi.getText(), null);
						else
						{
					String otext = vstr.getText();
					value = new Option(oi.getText(), otext.substring(1,otext.length()-1));
						}
					
				}
				break;
			}
			case LITERAL_newcontext:
			{
				match(LITERAL_newcontext);
				{
				switch ( LA(1)) {
				case STRING:
				{
					cstr = LT(1);
					match(STRING);
					break;
				}
				case SEMICOLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					
						if (cstr == null)
						  value = new ContextC(null);
						else
						{
					String s = cstr.getText();
						  value = new ContextC(s.substring(1,s.length()-1));
						}
					
				}
				break;
			}
			case SEMICOLON:
			{
				match(SEMICOLON);
				if ( inputState.guessing==0 ) {
					value = new Empty();
				}
				break;
			}
			case EOF:
			{
				match(Token.EOF_TYPE);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException e) {
			if (inputState.guessing==0) {
				
				State.setLabels(false);
				State.setError(e.toString()); 
				consumeUntil(SEMICOLON); consume();
				return new Empty();
				
			} else {
				throw e;
			}
		}
		catch (TokenStreamException e) {
			if (inputState.guessing==0) {
				
				State.setLabels(false);
				State.setError(e.toString()); 
				try
				{ State.getLexer().consumeUntil(';'); State.getLexer().consume(); }
				catch(antlr.CharStreamException f)
				{ }
				return new Empty();
				
			} else {
				throw e;
			}
		}
		return value;
	}
	
	public final Declaration  declaration() throws RecognitionException, TokenStreamException {
		 Declaration decl = null ; ;
		
		Token  i = null;
		Type t=null; Expression v=null;
		
		i = LT(1);
		match(IDENT);
		match(47);
		{
		switch ( LA(1)) {
		case LITERAL_TYPE:
		{
			match(LITERAL_TYPE);
			{
			switch ( LA(1)) {
			case 45:
			{
				match(45);
				t=typeExp();
				break;
			}
			case SEMICOLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				decl = Construct.typeDeclaration(
				Construct.typeDeclIdentifier(i.getText()), t);
			}
			break;
		}
		case LITERAL_FORMULA:
		{
			match(LITERAL_FORMULA);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				decl = Construct.formulaDeclaration(
				Construct.formulaDeclIdentifier(i.getText()), v);
			}
			break;
		}
		case LITERAL_AXIOM:
		{
			match(LITERAL_AXIOM);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				decl = Construct.axiomDeclaration(
				Construct.formulaDeclIdentifier(i.getText()), v);
			}
			break;
		}
		case IDENT:
		case 52:
		case LITERAL_ARRAY:
		case LITERAL_BOOLEAN:
		case LITERAL_BIT:
		case LITERAL_LOGICAL:
		case LITERAL_INT:
		case LITERAL_NAT:
		case LITERAL_REAL:
		case 62:
		case 64:
		case LITERAL_SUBTYPE:
		{
			t=typeExp();
			{
			switch ( LA(1)) {
			case 45:
			{
				match(45);
				v=valueExp();
				break;
			}
			case SEMICOLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			if ( inputState.guessing==0 ) {
				decl = Construct.valueDeclaration(
				Construct.valueDeclIdentifier(i.getText()), t, v);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return decl;
	}
	
	public final Expression  valueExp() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		TypedIdentifier[] p = null; Expression v = null;
		
		switch ( LA(1)) {
		case LITERAL_LAMBDA:
		{
			match(LITERAL_LAMBDA);
			p=paramList();
			match(47);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.lambdaTerm(p, v);
			}
			break;
		}
		case LITERAL_ARRAY:
		{
			match(LITERAL_ARRAY);
			p=paramList();
			match(47);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.arrayTerm(p, v);
			}
			break;
		}
		case LITERAL_FORALL:
		{
			match(LITERAL_FORALL);
			p=paramList();
			match(47);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.forallFormula(p, v);
			}
			break;
		}
		case LITERAL_EXISTS:
		{
			match(LITERAL_EXISTS);
			p=paramList();
			match(47);
			v=valueExp();
			if ( inputState.guessing==0 ) {
				value = Construct.existsFormula(p, v);
			}
			break;
		}
		case IDENT:
		case 52:
		case LITERAL_LET:
		case LITERAL_NOT:
		case 84:
		case 85:
		case 91:
		case NUMBER:
		case UNDERSCORE:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case LITERAL_LOGICALTRUE:
		case LITERAL_LOGICALFALSE:
		case LITERAL_BITTRUE:
		case LITERAL_BITFALSE:
		case 103:
		case LITERAL_IF:
		{
			value=valueExp90();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final Type  typeExp() throws RecognitionException, TokenStreamException {
		 Type type=null; ;
		
		Type t0 = null; Type t1 = null; Vector v = null;
		
		boolean synPredMatched35 = false;
		if (((_tokenSet_0.member(LA(1))))) {
			int _m35 = mark();
			synPredMatched35 = true;
			inputState.guessing++;
			try {
				{
				typeExpBase();
				match(51);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched35 = false;
			}
			rewind(_m35);
inputState.guessing--;
		}
		if ( synPredMatched35 ) {
			t0=typeExpBase();
			match(51);
			t1=typeExp();
			if ( inputState.guessing==0 ) {
				type = Construct.functionType(new Type[] { t0 }, t1);
			}
		}
		else {
			boolean synPredMatched37 = false;
			if (((LA(1)==52))) {
				int _m37 = mark();
				synPredMatched37 = true;
				inputState.guessing++;
				try {
					{
					match(52);
					typeExp();
					match(18);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched37 = false;
				}
				rewind(_m37);
inputState.guessing--;
			}
			if ( synPredMatched37 ) {
				match(52);
				t0=typeExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(t0);
				}
				{
				int _cnt39=0;
				_loop39:
				do {
					if ((LA(1)==18)) {
						match(18);
						t0=typeExp();
						if ( inputState.guessing==0 ) {
							v.add(t0);
						}
					}
					else {
						if ( _cnt39>=1 ) { break _loop39; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt39++;
				} while (true);
				}
				match(53);
				match(51);
				t1=typeExp();
				if ( inputState.guessing==0 ) {
					type = Construct.functionType(ASTUtil.toTypeArray(v), t1);
				}
			}
			else if ((LA(1)==LITERAL_ARRAY)) {
				match(LITERAL_ARRAY);
				t0=typeExpBase();
				match(LITERAL_OF);
				t1=typeExp();
				if ( inputState.guessing==0 ) {
					type = Construct.arrayType(t0, t1);
				}
			}
			else if ((_tokenSet_0.member(LA(1)))) {
				t0=typeExpBase();
				if ( inputState.guessing==0 ) {
					type = t0;
				}
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			return type;
		}
		
	public final Type  typeExpBase() throws RecognitionException, TokenStreamException {
		 Type type = null; ;
		
		Token  i = null;
		Token  i1 = null;
		Token  i2 = null;
		Type t0 = null; Type t1 = null; 
		Expression v0 = null; Expression v1 = null; Vector v = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			i = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				type = Construct.reference(i.getText());
			}
			break;
		}
		case LITERAL_BOOLEAN:
		{
			match(LITERAL_BOOLEAN);
			if ( inputState.guessing==0 ) {
				
				if (State.booleanAsLogical())
				type = Construct.atomicType("BIT"); 
				else
				type = Construct.atomicType("BOOLEAN");
			}
			break;
		}
		case LITERAL_BIT:
		{
			match(LITERAL_BIT);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("BIT");
			}
			break;
		}
		case LITERAL_LOGICAL:
		{
			match(LITERAL_LOGICAL);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("BOOLEAN");
			}
			break;
		}
		case LITERAL_INT:
		{
			match(LITERAL_INT);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("INT");
			}
			break;
		}
		case LITERAL_NAT:
		{
			match(LITERAL_NAT);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("NAT");
			}
			break;
		}
		case LITERAL_REAL:
		{
			match(LITERAL_REAL);
			if ( inputState.guessing==0 ) {
				type = Construct.atomicType("REAL");
			}
			break;
		}
		case 64:
		{
			match(64);
			if ( inputState.guessing==0 ) {
				v = new Vector();
			}
			i1 = LT(1);
			match(IDENT);
			match(47);
			t0=typeExp();
			if ( inputState.guessing==0 ) {
				v.add(Construct.typedIdentifier(
						   Construct.valueDeclIdentifier(i1.getText()), t0));
			}
			{
			_loop48:
			do {
				if ((LA(1)==18)) {
					match(18);
					i2 = LT(1);
					match(IDENT);
					match(47);
					t0=typeExp();
					if ( inputState.guessing==0 ) {
						v.add(Construct.typedIdentifier(
							       Construct.valueDeclIdentifier(i2.getText()), t0));
					}
				}
				else {
					break _loop48;
				}
				
			} while (true);
			}
			match(65);
			if ( inputState.guessing==0 ) {
				type = Construct.recordType(ASTUtil.toTypedIdentifierArray(v));
			}
			break;
		}
		case LITERAL_SUBTYPE:
		{
			match(LITERAL_SUBTYPE);
			match(52);
			v0=valueExp();
			match(53);
			if ( inputState.guessing==0 ) {
				type = Construct.subType(v0);
			}
			break;
		}
		case 52:
		{
			match(52);
			t0=typeExp();
			match(53);
			if ( inputState.guessing==0 ) {
				type = t0;
			}
			break;
		}
		default:
			boolean synPredMatched42 = false;
			if (((LA(1)==62))) {
				int _m42 = mark();
				synPredMatched42 = true;
				inputState.guessing++;
				try {
					{
					match(62);
					typeExp();
					match(18);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched42 = false;
				}
				rewind(_m42);
inputState.guessing--;
			}
			if ( synPredMatched42 ) {
				match(62);
				if ( inputState.guessing==0 ) {
					v = new Vector();
				}
				t0=typeExp();
				if ( inputState.guessing==0 ) {
					v.add(t0);
				}
				{
				int _cnt44=0;
				_loop44:
				do {
					if ((LA(1)==18)) {
						match(18);
						t1=typeExp();
						if ( inputState.guessing==0 ) {
							v.add(t1);
						}
					}
					else {
						if ( _cnt44>=1 ) { break _loop44; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt44++;
				} while (true);
				}
				match(63);
				if ( inputState.guessing==0 ) {
					type = Construct.tupleType(ASTUtil.toTypeArray(v));
				}
			}
			else {
				boolean synPredMatched46 = false;
				if (((LA(1)==62))) {
					int _m46 = mark();
					synPredMatched46 = true;
					inputState.guessing++;
					try {
						{
						match(62);
						typeExp();
						match(63);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched46 = false;
					}
					rewind(_m46);
inputState.guessing--;
				}
				if ( synPredMatched46 ) {
					match(62);
					t0=typeExp();
					match(63);
					if ( inputState.guessing==0 ) {
						type = t0;
					}
				}
				else if ((LA(1)==62)) {
					match(62);
					v0=valueExp();
					match(67);
					v1=valueExp();
					match(63);
					if ( inputState.guessing==0 ) {
						type = Construct.subrangeType(v0, v1);
					}
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}}
			return type;
		}
		
	public final TypedIdentifier[]  paramList() throws RecognitionException, TokenStreamException {
		 TypedIdentifier[] params = null; ;
		
		Vector sequence = new Vector();
		
		match(52);
		param(sequence);
		{
		_loop105:
		do {
			if ((LA(1)==18)) {
				match(18);
				param(sequence);
			}
			else {
				break _loop105;
			}
			
		} while (true);
		}
		match(53);
		if ( inputState.guessing==0 ) {
			params = ASTUtil.toTypedIdentifierArray(sequence);
		}
		return params;
	}
	
	public final Expression  valueExp90() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		ValueDeclaration v1 = null; ValueDeclaration v2 = null; Expression v3=null; 
			Vector v = null;
		
		switch ( LA(1)) {
		case LITERAL_LET:
		{
			match(LITERAL_LET);
			v1=vdeclaration();
			if ( inputState.guessing==0 ) {
				v = new Vector(); v.add(v1);
			}
			{
			_loop54:
			do {
				if ((LA(1)==18)) {
					match(18);
					v2=vdeclaration();
					if ( inputState.guessing==0 ) {
						v.add(v2);
					}
				}
				else {
					break _loop54;
				}
				
			} while (true);
			}
			match(LITERAL_IN);
			v3=valueExp90();
			if ( inputState.guessing==0 ) {
				value = Construct.letExpression(ASTUtil.toValueDeclarationArray(v), v3);
			}
			break;
		}
		case IDENT:
		case 52:
		case LITERAL_NOT:
		case 84:
		case 85:
		case 91:
		case NUMBER:
		case UNDERSCORE:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case LITERAL_LOGICALTRUE:
		case LITERAL_LOGICALFALSE:
		case LITERAL_BITTRUE:
		case LITERAL_BITFALSE:
		case 103:
		case LITERAL_IF:
		{
			value=valueExp70();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final ValueDeclaration  vdeclaration() throws RecognitionException, TokenStreamException {
		 ValueDeclaration decl = null ; ;
		
		Token  i = null;
		Type t=null; Expression v=null;
		
		i = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case 47:
		{
			match(47);
			t=typeExp();
			break;
		}
		case 45:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(45);
		v=valueExp();
		if ( inputState.guessing==0 ) {
			decl = Construct.valueDeclaration(
				          Construct.valueDeclIdentifier(i.getText()), t, v);
		}
		return decl;
	}
	
	public final Expression  valueExp70() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v0 = null;
		
		boolean synPredMatched57 = false;
		if (((_tokenSet_1.member(LA(1))))) {
			int _m57 = mark();
			synPredMatched57 = true;
			inputState.guessing++;
			try {
				{
				valueExp60();
				match(73);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched57 = false;
			}
			rewind(_m57);
inputState.guessing--;
		}
		if ( synPredMatched57 ) {
			value=valueExp60();
			match(73);
			v0=valueExp70();
			if ( inputState.guessing==0 ) {
				value = Construct.impliesFormula(value, v0);
			}
		}
		else if ((_tokenSet_1.member(LA(1)))) {
			value=valueExp60();
			{
			_loop59:
			do {
				if ((LA(1)==74)) {
					match(74);
					v0=valueExp70();
					if ( inputState.guessing==0 ) {
						value = Construct.equivalentFormula(value, v0);
					}
				}
				else if ((LA(1)==LITERAL_XOR)) {
					match(LITERAL_XOR);
					v0=valueExp70();
					if ( inputState.guessing==0 ) {
						value = Construct.notEquivalentFormula(value, v0);
					}
				}
				else {
					break _loop59;
				}
				
			} while (true);
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		return value;
	}
	
	public final Expression  valueExp60() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp50();
		{
		_loop62:
		do {
			if ((LA(1)==LITERAL_OR)) {
				match(LITERAL_OR);
				v=valueExp60();
				if ( inputState.guessing==0 ) {
					value = Construct.orFormula(value, v);
				}
			}
			else {
				break _loop62;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp50() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp45();
		{
		_loop65:
		do {
			if ((LA(1)==LITERAL_AND)) {
				match(LITERAL_AND);
				v=valueExp50();
				if ( inputState.guessing==0 ) {
					value = Construct.andFormula(value, v);
				}
			}
			else {
				break _loop65;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp45() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		switch ( LA(1)) {
		case LITERAL_NOT:
		{
			match(LITERAL_NOT);
			v=valueExp45();
			if ( inputState.guessing==0 ) {
				value = Construct.notFormula(v);
			}
			break;
		}
		case IDENT:
		case 52:
		case 84:
		case 85:
		case 91:
		case NUMBER:
		case UNDERSCORE:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case LITERAL_LOGICALTRUE:
		case LITERAL_LOGICALFALSE:
		case LITERAL_BITTRUE:
		case LITERAL_BITFALSE:
		case 103:
		case LITERAL_IF:
		{
			value=valueExp43();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final Expression  valueExp43() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp40();
		{
		switch ( LA(1)) {
		case 45:
		{
			match(45);
			v=valueExp43();
			if ( inputState.guessing==0 ) {
				value = Construct.equalsFormula(value, v);
			}
			break;
		}
		case 79:
		{
			match(79);
			v=valueExp43();
			if ( inputState.guessing==0 ) {
				value = Construct.notEqualsFormula(value, v);
			}
			break;
		}
		case SEMICOLON:
		case 18:
		case LITERAL_in:
		case 53:
		case 63:
		case 67:
		case LITERAL_IN:
		case 73:
		case 74:
		case LITERAL_XOR:
		case LITERAL_OR:
		case LITERAL_AND:
		case 104:
		case LITERAL_THEN:
		case LITERAL_ELSIF:
		case LITERAL_ELSE:
		case LITERAL_ENDIF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return value;
	}
	
	public final Expression  valueExp40() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp30();
		{
		switch ( LA(1)) {
		case 80:
		{
			match(80);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.lessFormula(value, v);
			}
			break;
		}
		case 81:
		{
			match(81);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.lessEqualFormula(value, v);
			}
			break;
		}
		case 82:
		{
			match(82);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.greaterFormula(value, v);
			}
			break;
		}
		case 83:
		{
			match(83);
			v=valueExp40();
			if ( inputState.guessing==0 ) {
				value = Construct.greaterEqualFormula(value, v);
			}
			break;
		}
		case SEMICOLON:
		case 18:
		case LITERAL_in:
		case 45:
		case 53:
		case 63:
		case 67:
		case LITERAL_IN:
		case 73:
		case 74:
		case LITERAL_XOR:
		case LITERAL_OR:
		case LITERAL_AND:
		case 79:
		case 104:
		case LITERAL_THEN:
		case LITERAL_ELSIF:
		case LITERAL_ELSE:
		case LITERAL_ENDIF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return value;
	}
	
	public final Expression  valueExp30() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp10();
		{
		_loop73:
		do {
			switch ( LA(1)) {
			case 84:
			{
				match(84);
				v=valueExp10();
				if ( inputState.guessing==0 ) {
					value = Construct.plusTerm(value, v);
				}
				break;
			}
			case 85:
			{
				match(85);
				v=valueExp10();
				if ( inputState.guessing==0 ) {
					value = Construct.minusTerm(value, v);
				}
				break;
			}
			case 86:
			{
				match(86);
				v=valueExp10();
				if ( inputState.guessing==0 ) {
					value = Construct.bitOrTerm(value, v);
				}
				break;
			}
			default:
			{
				break _loop73;
			}
			}
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp10() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp9();
		{
		_loop76:
		do {
			switch ( LA(1)) {
			case 87:
			{
				match(87);
				v=valueExp9();
				if ( inputState.guessing==0 ) {
					value = Construct.timesTerm(value, v);
				}
				break;
			}
			case 88:
			{
				match(88);
				v=valueExp9();
				if ( inputState.guessing==0 ) {
					value = Construct.dividesTerm(value, v);
				}
				break;
			}
			case 89:
			{
				match(89);
				v=valueExp9();
				if ( inputState.guessing==0 ) {
					value = Construct.bitAndTerm(value, v);
				}
				break;
			}
			default:
			{
				break _loop76;
			}
			}
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp9() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v = null;
		
		value=valueExp8();
		{
		_loop79:
		do {
			if ((LA(1)==90)) {
				match(90);
				v=valueExp8();
				if ( inputState.guessing==0 ) {
					value = Construct.powerTerm(value, v);
				}
			}
			else {
				break _loop79;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp8() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Expression v1 = null;
		
		switch ( LA(1)) {
		case 84:
		{
			match(84);
			v1=valueExp6();
			if ( inputState.guessing==0 ) {
				value = v1;
			}
			break;
		}
		case 85:
		{
			match(85);
			v1=valueExp6();
			if ( inputState.guessing==0 ) {
				value = Construct.negationTerm(v1);
			}
			break;
		}
		case 91:
		{
			match(91);
			v1=valueExp6();
			if ( inputState.guessing==0 ) {
				value = Construct.bitNotTerm(v1);
			}
			break;
		}
		case IDENT:
		case 52:
		case NUMBER:
		case UNDERSCORE:
		case LITERAL_TRUE:
		case LITERAL_FALSE:
		case LITERAL_LOGICALTRUE:
		case LITERAL_LOGICALFALSE:
		case LITERAL_BITTRUE:
		case LITERAL_BITFALSE:
		case 103:
		case LITERAL_IF:
		{
			value=valueExp6();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final Expression  valueExp6() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Token  m = null;
		Token  i = null;
		Expression v0 = null; Expression v1 = null; Vector v = null;
		
		value=valueExp5();
		{
		_loop86:
		do {
			if ((LA(1)==LITERAL_WITH)) {
				match(LITERAL_WITH);
				if ( inputState.guessing==0 ) {
					v = new Vector();
				}
				{
				int _cnt85=0;
				_loop85:
				do {
					switch ( LA(1)) {
					case 93:
					{
						match(93);
						{
						switch ( LA(1)) {
						case NUMBER:
						{
							m = LT(1);
							match(NUMBER);
							if ( inputState.guessing==0 ) {
								v.add(Construct.selectorNumber(
									    Construct.number(m.getText())));
							}
							break;
						}
						case IDENT:
						{
							i = LT(1);
							match(IDENT);
							if ( inputState.guessing==0 ) {
								v.add(Construct.selectorIdentifier(
									    Construct.reference(i.getText())));
							}
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						break;
					}
					case 62:
					{
						match(62);
						v0=valueExp();
						match(63);
						if ( inputState.guessing==0 ) {
							v.add(Construct.selectorIndex(v0));
						}
						break;
					}
					default:
					{
						if ( _cnt85>=1 ) { break _loop85; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					}
					_cnt85++;
				} while (true);
				}
				match(95);
				v1=valueExp5();
				if ( inputState.guessing==0 ) {
					value = Construct.updateTerm(value, 
						ASTUtil.toSelectorArray(v), v1);
				}
			}
			else {
				break _loop86;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp5() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Token  n = null;
		Token  j = null;
		Expression v0 = null; Expression v1 = null; Vector v = null;
		
		value=valueExp3();
		{
		_loop90:
		do {
			switch ( LA(1)) {
			case 93:
			{
				match(93);
				{
				switch ( LA(1)) {
				case NUMBER:
				{
					n = LT(1);
					match(NUMBER);
					if ( inputState.guessing==0 ) {
						value = Construct.selectionTerm(value, 
							      Construct.selectorNumber(Construct.number(n.getText())));
					}
					break;
				}
				case IDENT:
				{
					j = LT(1);
					match(IDENT);
					if ( inputState.guessing==0 ) {
						value = Construct.selectionTerm(value, 
							      Construct.selectorIdentifier(Construct.reference(j.getText())));
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case 62:
			{
				match(62);
				v0=valueExp();
				match(63);
				if ( inputState.guessing==0 ) {
					value = Construct.selectionTerm(value, 
						Construct.selectorIndex(v0));
				}
				break;
			}
			default:
			{
				break _loop90;
			}
			}
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp3() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Vector v = null; Expression v0 = null;
		
		value=valueExp0();
		{
		_loop95:
		do {
			if ((LA(1)==52)) {
				match(52);
				v0=valueExp();
				if ( inputState.guessing==0 ) {
					v = new Vector(); v.add(v0);
				}
				{
				_loop94:
				do {
					if ((LA(1)==18)) {
						match(18);
						v0=valueExp();
						if ( inputState.guessing==0 ) {
							v.add(v0);
						}
					}
					else {
						break _loop94;
					}
					
				} while (true);
				}
				match(53);
				if ( inputState.guessing==0 ) {
					value = Construct.applicationExpression(value, 
						ASTUtil.toExpressionArray(v));
				}
			}
			else {
				break _loop95;
			}
			
		} while (true);
		}
		return value;
	}
	
	public final Expression  valueExp0() throws RecognitionException, TokenStreamException {
		 Expression value = null; ;
		
		Token  i = null;
		Token  u = null;
		Token  n = null;
		Token  i1 = null;
		Token  i2 = null;
		Expression v1 = null; Expression v2 = null; Expression v3 = null;
		Vector v = null; Stack s = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			i = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				value = Construct.reference(i.getText());
			}
			break;
		}
		case UNDERSCORE:
		{
			u = LT(1);
			match(UNDERSCORE);
			if ( inputState.guessing==0 ) {
				value = Construct.reference(u.getText());
			}
			break;
		}
		case NUMBER:
		{
			n = LT(1);
			match(NUMBER);
			if ( inputState.guessing==0 ) {
				value = Construct.number(n.getText());
			}
			break;
		}
		case LITERAL_TRUE:
		{
			match(LITERAL_TRUE);
			if ( inputState.guessing==0 ) {
				if (State.booleanAsLogical())
				value = Construct.bitLogical(true);
				else
				value = Construct.logical(true); 
				
			}
			break;
		}
		case LITERAL_FALSE:
		{
			match(LITERAL_FALSE);
			if ( inputState.guessing==0 ) {
				if (State.booleanAsLogical())
				value = Construct.bitLogical(false);
				else
				value = Construct.logical(false); 
				
			}
			break;
		}
		case LITERAL_LOGICALTRUE:
		{
			match(LITERAL_LOGICALTRUE);
			if ( inputState.guessing==0 ) {
				value = Construct.logical(true);
			}
			break;
		}
		case LITERAL_LOGICALFALSE:
		{
			match(LITERAL_LOGICALFALSE);
			if ( inputState.guessing==0 ) {
				value = Construct.logical(false);
			}
			break;
		}
		case LITERAL_BITTRUE:
		{
			match(LITERAL_BITTRUE);
			if ( inputState.guessing==0 ) {
				value = Construct.bitLogical(true);
			}
			break;
		}
		case LITERAL_BITFALSE:
		{
			match(LITERAL_BITFALSE);
			if ( inputState.guessing==0 ) {
				value = Construct.bitLogical(false);
			}
			break;
		}
		case 52:
		{
			match(52);
			v1=valueExp();
			if ( inputState.guessing==0 ) {
				v = new Vector(); v.add(v1);
			}
			{
			_loop98:
			do {
				if ((LA(1)==18)) {
					match(18);
					v2=valueExp();
					if ( inputState.guessing==0 ) {
						v.add(v2);
					}
				}
				else {
					break _loop98;
				}
				
			} while (true);
			}
			match(53);
			if ( inputState.guessing==0 ) {
				if (v.size()==1) 
					  value = (Expression)(v.elementAt(0));
					else 
					  value = Construct.tupleTerm(ASTUtil.toExpressionArray(v));
			}
			break;
		}
		case 103:
		{
			match(103);
			if ( inputState.guessing==0 ) {
				v = new Vector();
			}
			i1 = LT(1);
			match(IDENT);
			match(95);
			v1=valueExp();
			if ( inputState.guessing==0 ) {
				v.add(Construct.valuedIdentifier(
						   Construct.reference(i1.getText()), v1));
			}
			{
			_loop100:
			do {
				if ((LA(1)==18)) {
					match(18);
					i2 = LT(1);
					match(IDENT);
					match(95);
					v2=valueExp();
					if ( inputState.guessing==0 ) {
						v.add(Construct.valuedIdentifier(
							       Construct.reference(i2.getText()), v2));
					}
				}
				else {
					break _loop100;
				}
				
			} while (true);
			}
			match(104);
			if ( inputState.guessing==0 ) {
				value = Construct.recordTerm(ASTUtil.toValuedIdentifierArray(v));
			}
			break;
		}
		case LITERAL_IF:
		{
			match(LITERAL_IF);
			v1=valueExp();
			match(LITERAL_THEN);
			v2=valueExp();
			if ( inputState.guessing==0 ) {
				s = new Stack(); s.push(v1); s.push(v2);
			}
			{
			_loop102:
			do {
				if ((LA(1)==LITERAL_ELSIF)) {
					match(LITERAL_ELSIF);
					v1=valueExp();
					match(LITERAL_THEN);
					v2=valueExp();
					if ( inputState.guessing==0 ) {
						s.push(v1); s.push(v2);
					}
				}
				else {
					break _loop102;
				}
				
			} while (true);
			}
			match(LITERAL_ELSE);
			v3=valueExp();
			match(LITERAL_ENDIF);
			if ( inputState.guessing==0 ) {
				value = v3;
				do { v2 = (Expression)(s.pop()); v1 = (Expression)(s.pop()); 
					   value = Construct.ifThenElseExpression(v1, v2, value); 
				} while (!s.isEmpty());
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return value;
	}
	
	public final void param(
		Vector sequence
	) throws RecognitionException, TokenStreamException {
		
		Token  i1 = null;
		Token  i2 = null;
		Vector v = new Vector(); Type t=null;
		
		i1 = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			v.add(Construct.valueDeclIdentifier(i1.getText()));
		}
		{
		_loop108:
		do {
			if ((LA(1)==18)) {
				match(18);
				i2 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					v.add(Construct.valueDeclIdentifier(i2.getText()));
				}
			}
			else {
				break _loop108;
			}
			
		} while (true);
		}
		match(47);
		t=typeExp();
		if ( inputState.guessing==0 ) {
			Iterator i = v.iterator();
				while (i.hasNext()) 
				{ sequence.add(Construct.typedIdentifier(
					(ValueDeclIdentifier)(i.next()), t)); }
			
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"SEMICOLON",
		"\"tcc\"",
		"\"prove\"",
		"IDENT",
		"\"flip\"",
		"LABEL",
		"\"goal\"",
		"\"skolemize\"",
		"\"flatten\"",
		"\"split\"",
		"\"simplify\"",
		"\"decompose\"",
		"\"scatter\"",
		"\"auto\"",
		"\",\"",
		"\"autostar\"",
		"\"counterexample\"",
		"\"assume\"",
		"\"case\"",
		"\"lemma\"",
		"\"instantiate\"",
		"\"in\"",
		"\"typeaxiom\"",
		"\"expand\"",
		"\"induction\"",
		"\"open\"",
		"\"next\"",
		"\"prev\"",
		"\"goto\"",
		"\"undo\"",
		"\"redo\"",
		"\"environment\"",
		"\"proof\"",
		"\"state\"",
		"\"printt\"",
		"\"printv\"",
		"\"printf\"",
		"\"quit\"",
		"\"read\"",
		"STRING",
		"\"option\"",
		"\"=\"",
		"\"newcontext\"",
		"\":\"",
		"\"TYPE\"",
		"\"FORMULA\"",
		"\"AXIOM\"",
		"\"->\"",
		"\"(\"",
		"\")\"",
		"\"ARRAY\"",
		"\"OF\"",
		"\"BOOLEAN\"",
		"\"BIT\"",
		"\"LOGICAL\"",
		"\"INT\"",
		"\"NAT\"",
		"\"REAL\"",
		"\"[\"",
		"\"]\"",
		"\"[#\"",
		"\"#]\"",
		"\"SUBTYPE\"",
		"\"..\"",
		"\"LAMBDA\"",
		"\"FORALL\"",
		"\"EXISTS\"",
		"\"LET\"",
		"\"IN\"",
		"\"=>\"",
		"\"<=>\"",
		"\"XOR\"",
		"\"OR\"",
		"\"AND\"",
		"\"NOT\"",
		"\"/=\"",
		"\"<\"",
		"\"<=\"",
		"\">\"",
		"\">=\"",
		"\"+\"",
		"\"-\"",
		"\"|\"",
		"\"*\"",
		"\"/\"",
		"\"&\"",
		"\"^\"",
		"\"~\"",
		"\"WITH\"",
		"\".\"",
		"NUMBER",
		"\":=\"",
		"UNDERSCORE",
		"\"TRUE\"",
		"\"FALSE\"",
		"\"LOGICALTRUE\"",
		"\"LOGICALFALSE\"",
		"\"BITTRUE\"",
		"\"BITFALSE\"",
		"\"(#\"",
		"\"#)\"",
		"\"IF\"",
		"\"THEN\"",
		"\"ELSIF\"",
		"\"ELSE\"",
		"\"ENDIF\"",
		"IGNORE",
		"LPAR",
		"RPAR",
		"LBRACK",
		"RBRACK",
		"LPARGRID",
		"RPARGRID",
		"LBRACKGRID",
		"RBRACKGRID",
		"PERIOD",
		"COLON",
		"COMMA",
		"ASSIGNMENT",
		"EQUALITY",
		"NONEQUALITY",
		"LESS",
		"LESSEQ",
		"GREATER",
		"GREATEREQ",
		"PLUS",
		"MINUS",
		"BITOR",
		"TIMES",
		"DIVIDES",
		"BITAND",
		"POWER",
		"BITNOT",
		"IMPLIES",
		"EQUIV",
		"ARROW",
		"DOTDOT",
		"REALLETTER",
		"LETTER",
		"DIGIT",
		"WS",
		"EOL",
		"COMMENT"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 9155818042444218496L, 5L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 4503599627370624L, 3295451037696L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	
	}
